package org.ssssssss.magicboot.task;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Configuration;
import org.springframework.scheduling.annotation.EnableScheduling;
import org.springframework.scheduling.annotation.Scheduled;
import org.ssssssss.magicboot.controller.*;

import java.time.LocalDateTime;

@Configuration      //1.主要用于标记配置类，兼备Component的效果。
@EnableScheduling   // 2.开启定时任务
public class testTask {
    @Autowired
    UsceController user;

    @Autowired
    customerController customer;
    @Autowired
    customerContactController contact;
    @Autowired
    customerFinInfoController finInfo;
    @Autowired
    materialreqbillXTController materialreqbill;
    @Autowired
    returnapplicationController returnapplication;
    @Autowired
    priceapprovaController priceapprovaController;
    @Autowired
    ProjectObjController projectObjController;
    @Autowired
    ProjectNewOpportunityController projectNewOpportunityController;

    @Autowired
    intentionPredictionController intentionPredictionController;
    @Autowired
    salesPredictionController salesPredictionController;


    @Scheduled(cron = "*/45 * * * * ?")
    //或直接指定时间间隔，例如：5秒
    private void configureTasks() throws Exception {
        customer.getSynDataAdd();
        customer.getSynKH();
       // customer.getSynDataUpdate();
       // customer.getSynKHUPdate();

        materialreqbill.getOperation();
        materialreqbill.getSynDataAdd();
        materialreqbill.materialreqbillSave();

        projectObjController.getSynData();
        projectObjController.saveSynData();
        projectNewOpportunityController.getSynData();
        projectNewOpportunityController.saveSynData();

        intentionPredictionController.getSynDataAdd();
        intentionPredictionController.SynSave();
        intentionPredictionController.getClose();
        salesPredictionController.getSynDataAdd();
        salesPredictionController.SynSave();


        System.err.println("执行45s静态定时任务时间: " + LocalDateTime.now());
    }

    @Scheduled(cron = "*/90 * * * * ?")
    //或直接指定时间间隔，例如：5秒
    private void configureTasks2() throws Exception {
        returnapplication.getSynDataAdd();
        returnapplication.materialreqbillSave();

        priceapprovaController.getSynDataAdd();
        priceapprovaController.priceapprovaSave();

        contact.getSynDataAdd();
        contact.SaveSyn();
      //  finInfo.getSynDataAdd();
       // finInfo.SaveSyn();

        System.err.println("执行90s静态定时任务时间: " + LocalDateTime.now());
    }

   // @Scheduled(cron = "0 */30 * * * ?")
    //或直接指定时间间隔，例如：5秒
    private void configureTasks30() throws Exception {
        user.getUserData();
        user.saveSynUser();
        System.err.println("执行30min静态定时任务时间: " + LocalDateTime.now());
    }
}
